> For the complete documentation index, see [llms.txt](https://docs.uma.xyz/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.uma.xyz/developers/optimistic-oracle-v3/using-blacklisting-tokens-as-currency.md).

# Using Blacklisting Tokens as Currency

Using a token that allows backlisting (e.g. USDC) as your [assertTruth](https://github.com/UMAprotocol/protocol/blob/dd9d1fa988d8520ad36db145db13591e9a104fa9/packages/core/contracts/optimistic-oracle-v3/implementation/OptimisticOracleV3.sol#L138) `currency` opens up a griefing vector that integrators should be aware of.

The [assertTruth](https://github.com/UMAprotocol/protocol/blob/dd9d1fa988d8520ad36db145db13591e9a104fa9/packages/core/contracts/optimistic-oracle-v3/implementation/OptimisticOracleV3.sol#L138) and [disputeAssertion](https://github.com/UMAprotocol/protocol/blob/dd9d1fa988d8520ad36db145db13591e9a104fa9/packages/core/contracts/optimistic-oracle-v3/implementation/OptimisticOracleV3.sol#L220) functions allow the caller to set any address as the `asserter` and `disputer` that will receive payouts if their assertion/dispute is correct upon settlement. If a bad actor calls these functions and specifies a blacklisted address for repayment, the [settle](https://github.com/UMAprotocol/protocol/blob/dd9d1fa988d8520ad36db145db13591e9a104fa9/packages/core/contracts/optimistic-oracle-v2/implementation/OptimisticOracleV2.sol#L498) function will revert and cause the request to be frozen unless the address is unblacklisted. This costs malicious users their bonds and does not result in any gain, but freezing the assertion could cause issues for the integrator.

Integrations that use tokens with blacklisting functionality should ensure that they have a way to manage frozen assertions (e.g. an admin function that can ignore a frozen assertion) without negatively affecting their integration.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.uma.xyz/developers/optimistic-oracle-v3/using-blacklisting-tokens-as-currency.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
